# liulianmao

**liulianmao**是[@LaoshuBaby](https://github.com/LaoshuBaby)自用的一个在命令行或者IDE中使用的大语言模型客户端。本项目主要为鼠宝宝及友人提供服务，亦用作个人codebase在各种机器人和实验性项目中快速调用。

目前仅测试了OpenAI提供的服务。理论上亦可直接用于零一万物或通义千问的服务。

若需要快速切换不同模型，可使用通过[one-api](https://github.com/songquanpeng/one-api)或[new-api](https://github.com/Calcium-Ion/new-api)聚合后的token。

您可脱离IDE在纯命令行中无头调用，亦可在IDE中同时并列若干窗口，运行客户端交互式对话。

| Use in VSCode                    | Use in PyCharm                     |
|----------------------------------|------------------------------------|
| ![VSCode](screenshot_vscode.png) | ![PyCharm](screenshot_pycharm.png) |

如果您是希望寻找图形化的客户端，可以去隔壁的[ChatBox](https://github.com/Bin-Huang/chatbox)、[ChatHub](https://github.com/chathub-dev/chathub)或[LibreChat](https://github.com/danny-avila/LibreChat)看看。

仅提供简体中文文档。若有疑问您可以联系我。

## 配置方法

安装所需要的库：

```shell
pip install requests loguru
```

若需使用langchain，还需安装：

```shell
pip install langchain langchain_openai
```

在系统环境变量中配置`OPENAI_API_KEY`的值为你所使用的API，`OPENAI_BASE_URL`的值为你使用的服务商的endpoint。 （如果您配置过langchain，那就不需要再次配置了！）

如果您不懂什么是环境变量，也可以在同目录下放置同名文件，亦可在代码中硬编码，但鼠宝宝不推荐这么做。

## 示例

- `python your_script.py` 将使用默认的recipe（即["init", "chat"]）。
- `python your_script.py --recipe init other_operation` 将使用自定义的recipe（即["init", "other_operation"]）。
- `python your_script.py --question` 将打开并打印`question.txt`文件的内容，并使用默认的recipe。
- `python your_script.py --question --recipe init other_operation` 将打开并打印`question.txt`文件的内容，并使用自定义的recipe。

## 参考文档

虽然我觉得正常用户用不到这东西，给自己看方便debug的

* https://platform.openai.com/docs/api-reference/audio/createSpeech
* https://platform.openai.com/docs/guides/text-to-speech

## TODO

目前有如下亟待解决的主要问题

* 打包为各平台（Windows/MacOS，Linux用户请自求多福）上可独立执行的单文件程序，[“一键运行”](https://github.com/sherlock-project/sherlock/issues/2011)。
* 允许将会话内容直接投射到txt中，并读取其更改自动作为回复。
* 提供一个网页或GUI，直接映射两个文件的状态（可能没有必要，我们不是要重新发明一个图形化的客户端，已经有很多了）。

## 联系我

* Telegram: [@laoshubaby](https://t.me/laoshubaby)
* Email: [laoshubaby@protonmail.com](mailto:laoshubaby@protonmail.com)

~~( 虽然是MIT协议，您可以自由使用，但如果您是在GitHub上搜到的这个项目，建议使用前先与我咨询，因为可能真的不好用。若能帮到您，就算交个朋友啦！**φ(゜▽゜*)♪** )~~

## 关于命名

Q: 如果是硬凑LLM首字母缩写，为什么不用“溜溜梅”？

A: 我怕来告我。

Q: 如果我觉得鼠宝宝是在重新发明轮子，其实有很多这种简易客户端了，怎么办？

A: 好问题，我也觉得。

Q: 有没有类似榴莲猫的项目？

A: 如果您有小米智能音响，可以试试[yihong0618/xiaogpt](https://github.com/yihong0618/xiaogpt)，给小爱同学装上最强大脑。